#include <DAVE.h>                 //Declarations from DAVE Code Generation (includes SFR declaration)

//#include "tcpecho_raw.h"

#include <ETH_LWIP/lwip/include/lwip/sockets.h>

#include "ETH_LWIP/lwip/include/lwip/api.h"
#include "ETH_LWIP/lwip/include/lwip/def.h"
#include "ETH_LWIP/lwip/include/lwip/mem.h"
#include "ETH_LWIP/lwip/include/lwip/memp.h"
#include "ETH_LWIP/lwip/include/lwip/tcp.h"
#include "ETH_LWIP/lwip/include/lwip/tcpip.h"
#include "ETH_LWIP/lwip/include/lwip/udp.h"
#include "ETH_LWIP/lwip/include/lwip/etharp.h"
#include "ETH_LWIP/lwip/include/lwip/dhcp.h"
#include "ETH_LWIP/lwip/include/lwip/sockets.h"
#include "ETH_LWIP/lwip/include/lwip/netdb.h"
#include "ETH_LWIP/lwip/include/lwip/opt.h"
#include "ETH_LWIP/lwip/include/lwip/priv/tcp_priv.h"
#include "ETH_LWIP/lwip/include/lwip/debug.h"
#include "ETH_LWIP/lwip/include/lwip/stats.h"
#include "ETH_LWIP/lwip/include/lwip/ip.h"
#include "ETH_LWIP/lwip/include/lwip/ip4.h"
#include "ETH_LWIP/lwip/include/lwip/ip4_addr.h"
#include "ETH_LWIP/lwip/include/lwip/ip6.h"
#include "ETH_LWIP/lwip/include/lwip/ip6_addr.h"
#include "ETH_LWIP/lwip/include/lwip/nd6.h"

// Functions
void netif_status_cb(struct netif *netif);

void client_write();

void my_client_init(void);
static void client_close(struct tcp_pcb *pcb);
static err_t client_connected(void *arg, struct tcp_pcb *pcb, err_t err);
static err_t client_sent(void *arg, struct tcp_pcb *pcb, u16_t len);

void DelayMicroSeconds(uint32_t);
void DelayMilliSeconds(uint32_t);


int main(void)
{
  DAVE_STATUS_t status;

  status = DAVE_Init();           /* Initialization of DAVE APPs  */

  if(status != DAVE_STATUS_SUCCESS)
  {
    /* Placeholder for error handler code. The while loop below can be replaced with an user error handler. */
    XMC_DEBUG("DAVE APPs initialization failed\n");

    while(1U)
    {

    }
  }

  /* Placeholder for user application code. The while loop below can be replaced with user application code. */
  while(1U)
  {
	 DelayMilliSeconds(1);

	 sys_check_timeouts();

	 DelayMilliSeconds(1000);



	 client_write();
	 //my_client_init();
  }
}

void netif_status_cb(struct netif *netif)
{
  XMC_UNUSED_ARG(netif);
  netif_set_up(netif);

  while(0 == netif_is_up(netif))
  {
	  DelayMicroSeconds(250);
  }

  DIGITAL_IO_SetOutputLow(&ETH_Enable);
}

//void netif_status_cb(struct netif *netif)
//{
//  XMC_UNUSED_ARG(netif);
//
//  tcpecho_raw_init();
//
//  DIGITAL_IO_SetOutputLow(&ETH_Enable);
//}

void DelayMicroSeconds(uint32_t delay_val)
{
	// !!! Attention should be paid to the flanks ascent and descent (IO pins) !!!

	// Converts micro seconds to milli seconds with multiplication factor for TIMER_GetInterruptStatus().
	uint32_t delay_cnt = delay_val * 100U;

	TIMER_SetTimeInterval(&TIMER_0, delay_cnt);

	TIMER_Start(&TIMER_0);

	while(!TIMER_GetInterruptStatus(&TIMER_0));

	TIMER_Stop(&TIMER_0);
	TIMER_ClearEvent(&TIMER_0);
}

void DelayMilliSeconds(uint32_t delay_val)
{
	// Converts micro seconds to milli seconds with multiplication factor for TIMER_GetInterruptStatus().
	uint32_t delay_cnt = delay_val * 100000U;

	TIMER_SetTimeInterval(&TIMER_0, delay_cnt);

	TIMER_Start(&TIMER_0);

	while(!TIMER_GetInterruptStatus(&TIMER_0));

	TIMER_Stop(&TIMER_0);
	TIMER_ClearEvent(&TIMER_0);
}












static err_t close_con(void *arg, struct tcp_pcb *pcb, u16_t len)
{
  tcp_arg(pcb, NULL);
  tcp_sent(pcb, NULL);
  tcp_close(pcb);

  return ERR_OK;
}

void client_write(void)
{
  struct tcp_pcb *pcb;
  ip_addr_t server;
  err_t ret_val;
  int bufspace = 0;
  struct pbuf *pb;
  char *string = "Hello TCP World! Lorem ipsum dolor sit amet, consetetur sadipscing elitr\r\n";

  pb = pbuf_alloc(PBUF_TRANSPORT, 0, PBUF_REF);
  pb->payload = string;
  pb->len = pb->tot_len = strlen(string);


  IP4_ADDR(&server, 192,168,114,89);

  pcb = tcp_new(); // create tcp pcb
  tcp_bind(pcb, IP_ADDR_ANY, 8); //bind client port for outgoing connection
//tcp_arg(pcb, NULL);
  ret_val = tcp_connect(pcb, &server, 7, NULL); //connect to the server

  if (ret_val != ERR_OK)
  {
 //   printf("\r\n Error: %d\n", ret_val);
  }
  else
  {
//     printf("\r\n Connect ok [%d]", ret_val);
     bufspace = tcp_sndbuf(pcb); // get space which can be used to sent the data

     if (bufspace)
     {
       do
       {
          tcp_write(pcb, pb->payload,pb->len, 0);
//          printf("\r\nRet val: %d", ret_val);
        } while (ret_val == ERR_MEM);

       tcp_output(pcb);
       tcp_sent(pcb, close_con);
     }

//     tcp_close(pcb);
  }

  pbuf_free(pb);
}












void my_client_init(void)
{
   struct tcp_pcb *pcb;
   ip_addr_t dest;
   err_t ret_val;
   IP4_ADDR(&dest, 192, 168, 14, 89);

   pcb = tcp_new();
   tcp_bind(pcb, IP_ADDR_ANY, 8); //client port for outcoming connection
   tcp_arg(pcb, NULL);
ret_val = tcp_connect(pcb, &dest, 7, client_connected); //server port for incoming connection
   if (ret_val != ERR_OK)
printf("\tcp_connect(): Errors on return value, returned value is %d\n", ret_val);
}

static void client_close(struct tcp_pcb *pcb)
{
   tcp_arg(pcb, NULL);
   tcp_sent(pcb, NULL);
   tcp_close(pcb);

   printf("\nclient_close(): Closing...\n");
}

static err_t client_connected(void *arg, struct tcp_pcb *pcb, err_t err)
{
   char *string = "Hello!";
   LWIP_UNUSED_ARG(arg);

   if (err != ERR_OK)
printf("\nclient_connected(): err argument not set to ERR_OK, but is value is %d\n", err);

   else
   {
       tcp_sent(pcb, client_sent);
       tcp_write(pcb, string, sizeof(string), 0);
   }

   return err;
}

static err_t client_sent(void *arg, struct tcp_pcb *pcb, u16_t len)
{
   LWIP_UNUSED_ARG(arg);

   printf("\nclient_sent(): Number of bytes ACK'ed is %d", len);

   client_close(pcb);

   return ERR_OK;
}










